angular.module('manageCampaigns', ['ngResource', 'condition', 'wemServices', 'wemDirectives', 'picker', 'i18n', 'angularMoment', 'underscore', 'datatables', 'datatables.bootstrap', 'manageGoals'])
    .run(function ($rootScope, _) {
        $rootScope.getCurrentModuleResource = function (resourcePath) {
            return ManagersUtils.getCurrentModuleResource(resourcePath);
        };

        $rootScope.currencies = _.map({
            AED: "United Arab Emirates Dirham",
            AFN: "Afghan Afghani",
            ALL: "Albanian Lek",
            AMD: "Armenian Dram",
            ANG: "Netherlands Antillean Guilder",
            AOA: "Angolan Kwanza",
            ARS: "Argentine Peso",
            AUD: "Australian Dollar",
            AWG: "Aruban Florin",
            AZN: "Azerbaijani Manat",
            BAM: "Bosnia-Herzegovina Convertible Mark",
            BBD: "Barbadian Dollar",
            BDT: "Bangladeshi Taka",
            BGN: "Bulgarian Lev",
            BHD: "Bahraini Dinar",
            BIF: "Burundian Franc",
            BMD: "Bermudan Dollar",
            BND: "Brunei Dollar",
            BOB: "Bolivian Boliviano",
            BRL: "Brazilian Real",
            BSD: "Bahamian Dollar",
            BTC: "Bitcoin",
            BTN: "Bhutanese Ngultrum",
            BWP: "Botswanan Pula",
            BYR: "Belarusian Ruble",
            BZD: "Belize Dollar",
            CAD: "Canadian Dollar",
            CDF: "Congolese Franc",
            CHF: "Swiss Franc",
            CLF: "Chilean Unit of Account (UF)",
            CLP: "Chilean Peso",
            CNY: "Chinese Yuan",
            COP: "Colombian Peso",
            CRC: "Costa Rican Colón",
            CUC: "Cuban Convertible Peso",
            CUP: "Cuban Peso",
            CVE: "Cape Verdean Escudo",
            CZK: "Czech Republic Koruna",
            DJF: "Djiboutian Franc",
            DKK: "Danish Krone",
            DOP: "Dominican Peso",
            DZD: "Algerian Dinar",
            EEK: "Estonian Kroon",
            EGP: "Egyptian Pound",
            ERN: "Eritrean Nakfa",
            ETB: "Ethiopian Birr",
            EUR: "Euro",
            FJD: "Fijian Dollar",
            FKP: "Falkland Islands Pound",
            GBP: "British Pound Sterling",
            GEL: "Georgian Lari",
            GGP: "Guernsey Pound",
            GHS: "Ghanaian Cedi",
            GIP: "Gibraltar Pound",
            GMD: "Gambian Dalasi",
            GNF: "Guinean Franc",
            GTQ: "Guatemalan Quetzal",
            GYD: "Guyanaese Dollar",
            HKD: "Hong Kong Dollar",
            HNL: "Honduran Lempira",
            HRK: "Croatian Kuna",
            HTG: "Haitian Gourde",
            HUF: "Hungarian Forint",
            IDR: "Indonesian Rupiah",
            ILS: "Israeli New Sheqel",
            IMP: "Manx pound",
            INR: "Indian Rupee",
            IQD: "Iraqi Dinar",
            IRR: "Iranian Rial",
            ISK: "Icelandic Króna",
            JEP: "Jersey Pound",
            JMD: "Jamaican Dollar",
            JOD: "Jordanian Dinar",
            JPY: "Japanese Yen",
            KES: "Kenyan Shilling",
            KGS: "Kyrgystani Som",
            KHR: "Cambodian Riel",
            KMF: "Comorian Franc",
            KPW: "North Korean Won",
            KRW: "South Korean Won",
            KWD: "Kuwaiti Dinar",
            KYD: "Cayman Islands Dollar",
            KZT: "Kazakhstani Tenge",
            LAK: "Laotian Kip",
            LBP: "Lebanese Pound",
            LKR: "Sri Lankan Rupee",
            LRD: "Liberian Dollar",
            LSL: "Lesotho Loti",
            LTL: "Lithuanian Litas",
            LVL: "Latvian Lats",
            LYD: "Libyan Dinar",
            MAD: "Moroccan Dirham",
            MDL: "Moldovan Leu",
            MGA: "Malagasy Ariary",
            MKD: "Macedonian Denar",
            MMK: "Myanma Kyat",
            MNT: "Mongolian Tugrik",
            MOP: "Macanese Pataca",
            MRO: "Mauritanian Ouguiya",
            MTL: "Maltese Lira",
            MUR: "Mauritian Rupee",
            MVR: "Maldivian Rufiyaa",
            MWK: "Malawian Kwacha",
            MXN: "Mexican Peso",
            MYR: "Malaysian Ringgit",
            MZN: "Mozambican Metical",
            NAD: "Namibian Dollar",
            NGN: "Nigerian Naira",
            NIO: "Nicaraguan Córdoba",
            NOK: "Norwegian Krone",
            NPR: "Nepalese Rupee",
            NZD: "New Zealand Dollar",
            OMR: "Omani Rial",
            PAB: "Panamanian Balboa",
            PEN: "Peruvian Nuevo Sol",
            PGK: "Papua New Guinean Kina",
            PHP: "Philippine Peso",
            PKR: "Pakistani Rupee",
            PLN: "Polish Zloty",
            PYG: "Paraguayan Guarani",
            QAR: "Qatari Rial",
            RON: "Romanian Leu",
            RSD: "Serbian Dinar",
            RUB: "Russian Ruble",
            RWF: "Rwandan Franc",
            SAR: "Saudi Riyal",
            SBD: "Solomon Islands Dollar",
            SCR: "Seychellois Rupee",
            SDG: "Sudanese Pound",
            SEK: "Swedish Krona",
            SGD: "Singapore Dollar",
            SHP: "Saint Helena Pound",
            SLL: "Sierra Leonean Leone",
            SOS: "Somali Shilling",
            SRD: "Surinamese Dollar",
            STD: "São Tomé and Príncipe Dobra",
            SVC: "Salvadoran Colón",
            SYP: "Syrian Pound",
            SZL: "Swazi Lilangeni",
            THB: "Thai Baht",
            TJS: "Tajikistani Somoni",
            TMT: "Turkmenistani Manat",
            TND: "Tunisian Dinar",
            TOP: "Tongan Paʻanga",
            TRY: "Turkish Lira",
            TTD: "Trinidad and Tobago Dollar",
            TWD: "New Taiwan Dollar",
            TZS: "Tanzanian Shilling",
            UAH: "Ukrainian Hryvnia",
            UGX: "Ugandan Shilling",
            USD: "United States Dollar",
            UYU: "Uruguayan Peso",
            UZS: "Uzbekistan Som",
            VEF: "Venezuelan Bolívar Fuerte",
            VND: "Vietnamese Dong",
            VUV: "Vanuatu Vatu",
            WST: "Samoan Tala",
            XAF: "CFA Franc BEAC",
            XAG: "Silver (troy ounce)",
            XAU: "Gold (troy ounce)",
            XCD: "East Caribbean Dollar",
            XDR: "Special Drawing Rights",
            XOF: "CFA Franc BCEAO",
            XPF: "CFP Franc",
            YER: "Yemeni Rial",
            ZAR: "South African Rand",
            ZMK: "Zambian Kwacha (pre-2013)",
            ZMW: "Zambian Kwacha",
            ZWL: "Zimbabwean Dollar"
        }, function (name, symbol) {
            return {value: symbol, label: "(" + symbol + ") " + name}
        });

        $rootScope.timezones = _.map(moment.tz.names(), function (value) {
            return {label: value}
        });

        $rootScope.pagerUrl = ManagersContext.localTemplatesPath + "/dt-pager.html";
    })

    .service("campaignConditionService", function () {
        function escapeRegex(regex) {
            var result = regex.replace(/[\\\.\[\]\{\}\(\)\+\-\?\^\$\|]/g, "\\$&").replace(/\*/g, ".*");
            if (result.substr(0, 2) != ".*") {
                result = ".*" + result;
            }
            if (result.substr(result.length - 2) != ".*") {
                result += ".*";
            }
            return result;
        }

        this.createCampaignEntryCondition = function (type) {
            var entryCondition = {
                "parameterValues": {
                    "subConditions": [],
                    "operator": "and"
                },
                "type": "booleanCondition"
            };
            switch (type.value) {
                case 'landing':
                    entryCondition.parameterValues.subConditions.push({
                        "parameterValues": {
                            "propertyName": "duration",
                            "propertyValueInteger": 0,
                            "comparisonOperator": "equals"
                        },
                        "type": "sessionPropertyCondition"
                    });
                    entryCondition.parameterValues.subConditions.push({
                            "parameterValues": {
                                "pagePath": type.param
                            },
                            "type": "pageViewEventCondition"
                        }
                    );
                    break;
                case 'referrer':
                    entryCondition.parameterValues.subConditions.push({
                        "parameterValues": {
                            "propertyName": "duration",
                            "propertyValueInteger": 0,
                            "comparisonOperator": "equals"
                        },
                        "type": "sessionPropertyCondition"
                    });
                    entryCondition.parameterValues.subConditions.push({
                            "type": "pageViewEventCondition"
                        }
                    );
                    entryCondition.parameterValues.subConditions.push({
                            "parameterValues": {
                                "propertyName": "target.properties.pageInfo.referringURL",
                                "propertyValue": escapeRegex(type.param),
                                "comparisonOperator": "matchesRegex"
                            },
                            "type": "eventPropertyCondition"

                        }
                    );
                    break;
                case 'parameter':
                    entryCondition.parameterValues.subConditions.push({
                        "parameterValues": {
                            "propertyName": "duration",
                            "propertyValueInteger": 0,
                            "comparisonOperator": "equals"
                        },
                        "type": "sessionPropertyCondition"
                    });
                    entryCondition.parameterValues.subConditions.push({
                            "type": "pageViewEventCondition"
                        }
                    );
                    entryCondition.parameterValues.subConditions.push({
                            "parameterValues": {
                                "propertyName": "target.properties.pageInfo.destinationURL",
                                "propertyValue": escapeRegex(type.param),
                                "comparisonOperator": "matchesRegex"
                            },
                            "type": "eventPropertyCondition"

                        }
                    );
                    break;
            }
            return entryCondition;
        }
    })

    .controller('ManageCampaignsListCtrl', ['$scope', 'campaignService', 'campaignConditionService', 'queryService', 'definitionService', '$location', '$route',
        '$modal', '$timeout', 'goalService', 'ruleService', '_', 'DTOptionsBuilder', 'DTColumnBuilder', '$q', '$compile', 'i18nService', 'genericModal',
        function ($scope, campaignService, campaignConditionService, queryService, definitionService, $location, $route,
                  $modal, $timeout, goalService, ruleService, _, DTOptionsBuilder, DTColumnBuilder, $q, $compile, i18nService, genericModal) {

            $scope.loading = true;

            function serverData(sSource, aoData, fnCallback, oSettings) {
                var draw = _.find(aoData, function (x) {
                    return x.name == "draw"
                }).value;

                var start = _.find(aoData, function (x) {
                    return x.name == "start"
                }).value;

                var length = _.find(aoData, function (x) {
                    return x.name == "length"
                }).value;

                var order = _.map(_.find(aoData, function (x) {
                    return x.name == "order"
                }).value, function (o) {
                    var colName = ($scope.dtColumns[o.column].data ? $scope.dtColumns[o.column].data : $scope.dtColumns[o.column].mData);
                    return ManagersUtils.campaignPropertiesForColName[colName] ? (ManagersUtils.campaignPropertiesForColName[colName] + ":" + o.dir) : null;
                }).join(",");

                campaignService.queryDetails(campaignService.constructQuery(length, start, order))
                    .success(function (data) {
                        var convertedData = [];
                        angular.forEach(data.list, function (value, key) {
                            var startCampaignMoment = value.campaign.timezone != undefined ? moment(value.campaign.startDate).tz(value.campaign.timezone) : moment(value.campaign.startDate);
                            var endCampaignMoment = value.campaign.timezone != undefined ? moment(value.campaign.endDate).tz(value.campaign.timezone) : moment(value.campaign.endDate);

                            convertedData.push({
                                "id": value.campaign.metadata.id,
                                "name": value.campaign.metadata.name,
                                type: campaignService.getLocalizedCampaignType(campaignService.getCampaignType(value.campaign)),
                                "description": value.campaign.metadata.description,
                                "startDate": "<span>" + startCampaignMoment.format('LL') + "</span>",
                                "endDate": "<span>" + endCampaignMoment.format('LL') + "</span>",
                                "conversion": (value.conversionRate * 100).toFixed(2) + "%",
                                "engagedProfiles": value.engagedProfiles,
                                "numberOfGoals": value.numberOfGoals,
                                "primaryGoal" : value.campaign.primaryGoal
                            })
                        });
                        var results = {
                            "sEcho": draw,
                            "iTotalRecords": data.totalSize,
                            "iTotalDisplayRecords": data.totalSize,
                            "aaData": convertedData
                        };
                        fnCallback(results);
                        ManagersUtils.initPagerProperties($scope.dtInstance.DataTable, $scope, i18nService);
                        delete $scope.campaignRemoved;
                    }).error(function (data, status, headers, config) {
                        $scope.searchError = true;
                        var results = {
                            "sEcho": draw,
                            "iTotalRecords": 0,
                            "iTotalDisplayRecords": 0,
                            "aaData": []
                        };
                        fnCallback(results);
                    });
            }

            $scope.goalsByTag = {};

            $scope.dtOptions = DTOptionsBuilder.newOptions()
                .withOption('lengthMenu', [ 25, 50, 100 ])
                .withOption('pageLength', 25)
                .withOption('processing', true)
                .withOption('serverSide', true)
                .withOption('sDom', 't')
                .withOption('order', [[3, 'asc']])
                .withOption('createdRow', createdRow)
                .withFnServerData(serverData);

            $scope.dtColumns = [
                {
                    "data": 'name',
                    "title": i18nService.message("serverSettings.manageCampaigns.campaignName"),
                    "width": "10%"
                },
                {
                    data: 'type',
                    title: i18nService.message("serverSettings.manageCampaigns.type.short"),
                    width: '10%'
                },
                {
                    "data": 'description',
                    "title": i18nService.message("serverSettings.manageWem.description"),
                    "width": "10%"
                },
                {
                    "data": "startDate",
                    "title": i18nService.message("serverSettings.manageCampaigns.startDate"),
                    "width": "10%"
                },
                {
                    "data": "endDate",
                    "title": i18nService.message("serverSettings.manageCampaigns.endDate"),
                    "width": "10%"
                },
                DTColumnBuilder.newColumn("engagedProfiles").withTitle(i18nService.message("serverSettings.manageCampaigns.engaged")).notSortable()
                    .withOption("width", "5%"),
                DTColumnBuilder.newColumn("conversion").withTitle(i18nService.message("serverSettings.manageCampaigns.conversion.rate")).notSortable()
                    .withOption("width", "5%"),
                DTColumnBuilder.newColumn("numberOfGoals").withTitle(i18nService.message("serverSettings.manageCampaigns.goals")).notSortable()
                    .withOption("width", "5%"),
                DTColumnBuilder.newColumn(null).withTitle(i18nService.message("serverSettings.manageWem.listAction")).notSortable()
                    .renderWith(actionsHtml).withOption("width", "180px").withOption("contentPadding", "0")
            ];

            function createdRow(row, data, dataIndex) {
                console.log("Row is created: " + row);
                // Recompiling so we can bind Angular directive to the DT
                $compile(angular.element(row).contents())($scope);
            }

            function rowCallback(row, aData, iDisplayIndex, iDisplayIndexFull) {
                // Unbind first in order to avoid any duplicate handler (see https://github.com/l-lin/angular-datatables/issues/87)
                $('td:not(:last-child)', row).unbind('click');
                $('td:not(:last-child)', row).bind('click', function () {
                    $scope.$apply(function () {
                        $location.path('/campaigndashboard/' + aData.metadata.id);
                    });
                });
                return row;
            }

            function actionsHtml(data, type, full, meta) {
                return "<button title=\"" + i18nService.message("serverSettings.manageGoals.campaignDashboard") + "\" type=\"button\" class=\"btn btn-icon command-dashboard\" ng-click=\"goToDashboard('" + data.id + "')\"><span class=\"md md-dashboard\"></span></button> " +
                    "<button title=\"" + i18nService.message("serverSettings.manageCampaigns.manageEngagedProfiles") + "\" type=\"button\" class=\"btn btn-icon command-profiles\" ng-click=\"goToEngagedProfiles('" + data.id + "')\" ><span class=\"md md-people\"></span></button>" +
                    "<button title=\"" + i18nService.message("serverSettings.manageCampaigns.manageConvertedProfiles") + "\" type=\"button\" class=\"btn btn-icon command-profiles\" ng-click=\"goToConvertedProfiles('" + data.id + "', '" + data.primaryGoal + "')\" ><span class=\"md md-profiles\"></span></button>" +
                    "<button title=\"" + i18nService.message("serverSettings.manageWem.delete") + "\" type=\"button\" class=\"btn btn-icon command-delete\" ng-click=\"deleteCampaign('" + data.id + "', '" + data.name + "')\"><span class=\"md md-delete\"></span></button>";
            }

            $scope.goToDashboard = function (id) {
                $location.path("/campaigndashboard/" + id);
            };

            $scope.goToEngagedProfiles = function (id) {
                $location.path("/campaign/" + id + "/profiles");
            };

            $scope.goToConvertedProfiles = function (campaignId, goalId) {
                $location.path("/campaign/" + campaignId + "/converted/" + goalId);
            };

            $scope.goalsByTag = ManagersUtils.buildTags(ManagersUtils.campaingTags, i18nService);

            $scope.deleteCampaign = function (id, name) {
                genericModal.newAlertModal({
                    title: i18nService.message("serverSettings.manageWem.delete"),
                    bodyMessage: i18nService.format("serverSettings.manageCampaigns.delete.confirm", name)
                }, function () {
                    goalService.getAllForCampaign(id).success(function (goalsMetadatas){
                        campaignService.deleteCampaign(id).success(function () {
                            if(goalsMetadatas && goalsMetadatas.length) {
                                var promises = [];
                                _.forEach(goalsMetadatas, function (goal) {
                                    promises.push(ruleService.deleteRule(goalService.getAddToListRulePrefix() + goal.id));
                                });
                                $q.all(promises).then(function (data) {
                                    console.log("Add to list rules deleted successfully");
                                });
                            }
                        });
                        // reload the table
                        $scope.dtInstance.dataTable.fnDraw();
                    });
                });
            };

            $scope.setDtInstance = function (instance) {
                $scope.dtInstance = instance;
            };
        }])

    .controller('ManageCampaignCtrl', ['$scope', '$routeParams', '$resource', '$location', 'campaignService', 'i18nService', 'campaignConditionService', '$route', 'currentCampaign', 'genericModal', 'isNew',
        function ($scope, $routeParams, $resource, $location, campaignService, i18nService, campaignConditionService, $route, currentCampaign, genericModal, isNew) {
            $scope.currentCampaign = currentCampaign;
            $scope.isNew = isNew;

            $scope.dateOptions = {
                formatYear: 'yyyy',
                startingDay: 1
            };

            $scope.format = 'dd-MMMM-yyyy';

            //Timepicker functions
            $scope.dates = {
                startDate : moment($scope.currentCampaign.startDate).toDate().toISOString(),
                endDate : moment($scope.currentCampaign.endDate).toDate().toISOString(),
                startTime: new Date($scope.currentCampaign.startDate),
                endTime : new Date($scope.currentCampaign.endDate)
            };
            $scope.dates.startTime.setHours(moment($scope.dates.startDate).tz($scope.currentCampaign.timezone).hours());
            $scope.dates.endTime.setHours(moment($scope.dates.endDate).tz($scope.currentCampaign.timezone).hours());

            // campaign type and localized names of types
            $scope.currentCampaignType = {value: campaignService.getCampaignType($scope.currentCampaign)};
            $scope.$watch("currentCampaignType.value", function (newValue, oldValue) {
                if (angular.isDefined(oldValue) && newValue != oldValue) {
                    $scope.localizedCampaignType = campaignService.getLocalizedCampaignType($scope.currentCampaignType.value);
                }
            });
            $scope.localizedCampaignParam = campaignService.getLocalizedCampaignParam($scope.currentCampaignType.value);
            $scope.campaignIDTypes = [
                {name: campaignService.getLocalizedCampaignType('referrer'), value: 'referrer'},
                {name: campaignService.getLocalizedCampaignType('landing'), value: 'landing'},
                {name: campaignService.getLocalizedCampaignType('parameter'), value: 'parameter'}
            ];

            // Calendar functions
            $scope.open = function ($event, selector) {
                $event.preventDefault();
                $event.stopPropagation();
                if (selector == 'start')
                    $scope.startopened = true;
                if (selector == 'end')
                    $scope.endopened = true;
            };

            $scope.openDatePopup = function ($event, selector) {
                $event.preventDefault();
                $event.stopPropagation();
                if (selector == 'start') {
                    if (typeof $scope.startDatePicker === 'undefined') {
                        $scope.startDatePicker = {};
                    }
                    $scope.startDatePicker.opened = true;
                }
                if (selector == 'end') {
                    if (typeof $scope.endDatePicker === 'undefined') {
                        $scope.endDatePicker = {};
                    }
                    $scope.endDatePicker.opened = true;
                }
            };


            $scope.saveCampaign = function () {
                $scope.currentCampaign.metadata.tags = [$scope.currentCampaignType.value];
                $scope.currentCampaign.entryCondition = campaignConditionService.createCampaignEntryCondition($scope.currentCampaignType);

                $scope.currentCampaign.startDate = moment($scope.dates.startDate).tz($scope.currentCampaign.timezone);
                $scope.currentCampaign.startDate.hours($scope.dates.startTime.getHours());
                $scope.currentCampaign.startDate.minutes($scope.dates.startTime.getMinutes());
                $scope.currentCampaign.startDate.seconds(0);

                $scope.currentCampaign.endDate = moment($scope.dates.endDate).tz($scope.currentCampaign.timezone);
                $scope.currentCampaign.endDate.hours($scope.dates.endTime.getHours());
                $scope.currentCampaign.endDate.minutes($scope.dates.endTime.getMinutes());
                $scope.currentCampaign.endDate.seconds(0);

                if (!$scope.isNew) {
                    campaignService.setCampaign($scope.currentCampaign).success(function () {
                        campaignService.updatedCampaign = $scope.currentCampaign;
                        $location.path("/campaigndashboard/" + $scope.currentCampaign.metadata.id);
                    });
                } else {
                    campaignService.campaignToBeSaved = $scope.currentCampaign;
                    $location.path("/campaign/" + $scope.currentCampaign.metadata.id + "/newGoal");
                }
            };

            $scope.getPreviousPage = function () {
                return $scope.isNew ? "#/campaigns" : ("#/campaigndashboard/" + $scope.currentCampaign.metadata.id);
            };

            $scope.resetCampaign = function () {
                $route.reload();
            };

            if ($scope.currentCampaign.entryCondition) {
                $scope.currentCampaignType.param = campaignService.getTypeSpecificCampaignParameter($scope.currentCampaign);

                $scope.hasCampaignStarted = moment().isAfter($scope.currentCampaign.startDate);
                $scope.hasCampaignClosed = moment().isAfter($scope.currentCampaign.endDate);
            }
        }])

    .controller('CreateCampaignGoalCtrl', function ($scope, $location, _, i18nService, goalService, ruleService, currentCampaign, $controller, campaignService, notificationService) {
        angular.extend(this, $controller('CreateGoalCtrl', {
            $scope: $scope,
            $location: $location,
            i18nService: i18nService,
            _: _,
            goalService: goalService
        }));
        $scope.goal.campaignId = currentCampaign.metadata.id;

        var tags = _.map(ManagersUtils.buildTags(ManagersUtils.campaingTags, i18nService), function (tag, key) {
            return tag;
        });
        $scope.goalTags = angular.copy(tags);
        $scope.goal.type = $scope.goalTags[0];

        // execut the save() from the callback to build the goal based on the specific logic
        $scope.saveGoal = function (createForm) {
            if(createForm.$invalid){
                var parsedErrors = ManagersUtils.parseErrorsInForm(createForm);
                if(parsedErrors && Object.keys(parsedErrors).length > 0) {
                    ManagersUtils.displayErrors(parsedErrors, i18nService, notificationService);
                    return;
                }
            }


            $scope.callback.save(function() {
                $scope.goal.metadata.tags = [$scope.goal.type.id];
                delete $scope.goal.type;
                delete $scope.goal.startEvent;
                var lists = $scope.goal.lists;
                delete $scope.goal.lists;

                goalService.setGoal($scope.goal).success(function () {
                    ruleService.setRule(goalService.localToServerGoalRule($scope.goal, lists));
                    var newCampaign = campaignService.campaignToBeSaved;
                    if (newCampaign && newCampaign.metadata.id == $scope.goal.campaignId) {
                        newCampaign.primaryGoal = $scope.goal.metadata.id;
                        campaignService.setCampaign(newCampaign).success(function () {
                            delete campaignService.campaignToBeSaved;
                            $location.path("/campaigndashboard/" + $scope.goal.campaignId);
                        });
                    } else {
                        $location.path("/campaigndashboard/" + $scope.goal.campaignId);
                    }
                });
            }, true);
        };
    })


    .controller('ManageCampaignGoalsListCtrl', ['$scope', '$route', '$location', '$modal', 'goalService', 'queryService', 'definitionService', 'i18nService', 'campaignService', 'campaignDetailed', '_', '$controller', '$q', 'DTOptionsBuilder', 'DTColumnBuilder', '$compile', 'genericModal',
        function ($scope, $route, $location, $modal, goalService, queryService, definitionService, i18nService, campaignService, campaignDetailed, _, $controller, $q, DTOptionsBuilder, DTColumnBuilder, $compile, genericModal) {

            angular.extend(this, $controller('ManageGoalsListCtrl', {
                $scope: $scope,
                $route: $route,
                $location: $location,
                $modal: $modal,
                goalService: goalService,
                queryService: queryService,
                definitionService: definitionService,
                i18nService: i18nService,
                currentCampaign: campaignDetailed.campaign,
                _: _
            }));

            // campaign type and localized names of types
            $scope.currentCampaignType = {value: campaignService.getCampaignType($scope.currentCampaign), param: campaignService.getTypeSpecificCampaignParameter($scope.currentCampaign)};
            $scope.localizedCampaignType = campaignService.getLocalizedCampaignType($scope.currentCampaignType.value);
            $scope.localizedCampaignParam = campaignService.getLocalizedCampaignParam($scope.currentCampaignType.value);

            if (!_.isUndefined(campaignDetailed.campaign)) {
                // timeline data
                var drawCampaignEvents = function () {
                    if ($scope.campaignChart) {
                        var eventDates = {};
                        $.each($scope.campaignEvents, function (idx, event) {
                            var eventDateLabel = moment(event.eventDate).format($scope.timelineData.interval.scaleFormat);
                            if (eventDates[eventDateLabel] == undefined) {
                                eventDates[eventDateLabel] = eventDateLabel;
                            }
                        });
                        //now let's paint point with events in red.
                        var ctx = $scope.campaignChart.chart.ctx;
                        ctx.strokeStyle = "#FF0000";

                        var min;
                        var max;
                        $.each($scope.campaignChart.datasets, function (idx, dataset) {
                            $.each(dataset.points, function (idx, point) {
                                if (!min || point.y < min) min = point.y;
                                if (!max || point.y > max) max = point.y;
                            });
                        });
                        $.each($scope.campaignChart.datasets[0].points, function (idx, point) {
                            if (eventDates[point.label] != undefined) {
                                ctx.strokeRect(point.x - 10, min - 10, 20, max - min + 20);
                            }
                        });
                    }
                };

                $scope.timelineData.chartOptions = {
                    customTooltips: function (tooltip) {
                        if (tooltip) {
                            var eventNames = [];
                            $.each($scope.campaignEvents, function (idx, event) {
                                if (tooltip.title == (moment(event.eventDate).format($scope.timelineData.interval.scaleFormat))) {
                                    eventNames.push(event.metadata.name);
                                }
                            });
                            var labels = tooltip.labels;
                            var legendColors = tooltip.legendColors;
                            if (eventNames.length > 0) {
                                labels.push("Campaign Events: " + eventNames.join(','));
                                legendColors.push({fill: "rgba(128,0,0,1)", stroke: "#fff"})
                            }
                            new Chart.MultiTooltip({
                                x: tooltip.x,
                                y: tooltip.y,
                                xPadding: tooltip.xPadding,
                                yPadding: tooltip.yPadding,
                                xOffset: tooltip.xOffset,
                                fillColor: tooltip.fillColor,
                                textColor: tooltip.textColor,
                                fontFamily: tooltip.fontFamily,
                                fontStyle: tooltip.fontStyle,
                                fontSize: tooltip.fontSize,
                                titleTextColor: tooltip.titleTextColor,
                                titleFontFamily: tooltip.titleFontFamily,
                                titleFontStyle: tooltip.titleFontStyle,
                                titleFontSize: tooltip.titleFontSize,
                                cornerRadius: tooltip.cornerRadius,
                                labels: labels,
                                legendColors: legendColors,
                                legendColorBackground: tooltip.legendColorBackground,
                                title: tooltip.title,
                                chart: tooltip.chart,
                                ctx: tooltip.ctx,
                                custom: false
                            }).draw();
                        } else {
                            drawCampaignEvents();
                        }
                    },
                    onAnimationComplete: function () {
                        $scope.campaignChart = this;
                        drawCampaignEvents();
                    },
                    onAnimationProgress: function () {
                        $scope.campaignChart = this;
                        drawCampaignEvents();
                    }
                };
                $scope.timelineData.series = [i18nService.message('serverSettings.manageCampaigns.engaged'), i18nService.message('serverSettings.manageCampaigns.converted')];
                $scope.timelineData.loadData = function (success) {
                    var aggregateSessionQuery = {
                        "aggregate": {
                            "type": "date",
                            "parameters": {
                                "interval": this.interval.key,
                                "format": "yyyy-MM-dd"
                            }
                        },
                        "condition": {
                            "type": "booleanCondition",
                            "parameterValues": {
                                "operator": "and",
                                "subConditions": [
                                    {
                                        "type": "sessionPropertyCondition",
                                        "parameterValues": {
                                            "propertyName": "scope",
                                            "comparisonOperator": "equals",
                                            "propertyValue": ManagersContext.dmfScope
                                        }
                                    }
                                ]
                            }
                        }
                    };
                    aggregateSessionQuery.condition.parameterValues.subConditions.push(
                        {
                            "type": "sessionPropertyCondition",
                            "parameterValues": {
                                "propertyName": "systemProperties.campaigns." + this.currentCampaign.metadata.id + "Engaged",
                                "comparisonOperator": "between",
                                "propertyValuesDate": [
                                    this.currentCampaign.startDate,
                                    this.currentCampaign.endDate
                                ]
                            }
                        });
                    // get all sessions
                    queryService.query("session", "timeStamp", aggregateSessionQuery).success(function (aggregateSessionsData) {
                        var datasets = [];
                        datasets[0] = aggregateSessionsData;

                        // get new sessions:
                        aggregateSessionQuery.condition.parameterValues.subConditions.push({
                            "type": "sessionPropertyCondition",
                            "parameterValues": {
                                "propertyName": "systemProperties.goals." + $scope.timelineData.currentCampaign.primaryGoal + "TargetReached",
                                "comparisonOperator": "between",
                                "propertyValuesDate": [
                                    $scope.timelineData.currentCampaign.startDate,
                                    $scope.timelineData.currentCampaign.endDate
                                ]
                            }
                        });
                        queryService.query("session", "timeStamp", aggregateSessionQuery).success(function (aggregateNewSessionsData) {
                            datasets[1] = aggregateNewSessionsData;
                            campaignService.getCampaignEvents($scope.timelineData.currentCampaign.metadata.id, -1, 0, null, {
                                "type": "sessionPropertyCondition",
                                "parameterValues": {
                                    "propertyName": "eventDate",
                                    "comparisonOperator": "between",
                                    "propertyValuesDate": [
                                        $scope.timelineData.currentCampaign.startDate,
                                        $scope.timelineData.currentCampaign.endDate
                                    ]
                                }
                            }).success(function (result) {
                                $scope.campaignEvents = result.list;
                                success(datasets);
                            });
                        });
                    });
                };

                $scope.currentCampaign.KPI = {
                    engaged: campaignDetailed.engagedProfiles,
                    sessions: campaignDetailed.campaignSessionViews,
                    reached: campaignDetailed.campaignSessionSuccess,
                    cost_per_visitor: $scope.currentCampaign.cost / campaignDetailed.campaignSessionViews,
                    conversion_rate: campaignDetailed.conversionRate * 100,
                    conversion_cost: $scope.currentCampaign.cost / campaignDetailed.campaignSessionSuccess,
                    page_viewed: 0,
                    page_viewed_per_user: 0
                };

                queryService.nbOfVisits($scope.currentCampaign.metadata.id, $scope.currentCampaign.startDate, $scope.currentCampaign.endDate, function (metricsData) {
                    $scope.currentCampaign.KPI.page_viewed = metricsData._sum;
                    $scope.currentCampaign.KPI.page_viewed_per_user = metricsData._avg;
                });

                // events
                var currencyIcons = ['eur', 'usd', 'rub', 'krw', 'cny', 'gbp', 'inr', 'try', 'jpy', 'ils'];

                $scope.loading = true;

                function serverData(sSource, aoData, fnCallback, oSettings) {
                    var draw = _.find(aoData, function (x) {
                        return x.name == "draw"
                    }).value;

                    var start = _.find(aoData, function (x) {
                        return x.name == "start"
                    }).value;

                    var length = _.find(aoData, function (x) {
                        return x.name == "length"
                    }).value;

                    var order = _.map(_.find(aoData, function (x) {
                        return x.name == "order"
                    }).value, function (o) {
                        return ($scope.dtColumns[o.column].data ? $scope.dtColumns[o.column].data : $scope.dtColumns[o.column].mData)  + ":" + o.dir;
                    }).join(",");

                    campaignService.getCampaignEvents($scope.currentCampaign.metadata.id, length, start, order).success(function (data) {
                        var convertedData = [];
                        angular.forEach(data.list, function (value, key) {
                            var eventMoment = moment(value.eventDate).tz(value.timezone);
                            var localEventMoment = eventMoment.clone().tz(jstz.determine().name());

                            convertedData.push({
                                "metadata": {
                                    name: value.metadata.name,
                                    "id": value.metadata.id,
                                    "description": value.metadata.description
                                },
                                "eventDate": "<span data-tooltip='" + localEventMoment.format('LLLL z') + "'>" + eventMoment.format('LLLL z') + "&nbsp;(" + localEventMoment.fromNow() + ")" + "</span>",
                                "cost": (currencyIcons.indexOf(value.currency.toLowerCase()) > -1) ? "<span class='text-success'> <i class='fa fa-" + value.currency.toLowerCase() + "'/>" + value.cost + "</span>" : "<span class='text-success'>(" + value.currency + ")" + value.cost + "</span>"
                            })
                        });

                        var results = {
                            "sEcho": draw,
                            "iTotalRecords": data.totalSize,
                            "iTotalDisplayRecords": data.totalSize,
                            "aaData": convertedData
                        };
                        fnCallback(results);
                        ManagersUtils.initPagerProperties($scope.dtInstance.DataTable, $scope, i18nService);
                    }).error(function (data, status, headers, config) {
                        $scope.searchError = true;
                        var results = {
                            "sEcho": draw,
                            "iTotalRecords": 0,
                            "iTotalDisplayRecords": 0,
                            "aaData": []
                        };
                        fnCallback(results);
                    });
                }

                function createdRow(row, data, dataIndex) {
                    $compile(angular.element(row).contents())($scope);
                }

                $scope.dtOptions = DTOptionsBuilder.newOptions()
                    .withOption('processing', true)
                    .withOption('serverSide', true)
                    .withOption('sDom', 't')
                    .withOption('createdRow', createdRow)
                    .withOption('order', [[2, 'desc']])
                    .withFnServerData(serverData);

                $scope.dtColumns = [
                    DTColumnBuilder.newColumn("metadata.name").withTitle(i18nService.message("serverSettings.manageCampaigns.campaignName")),
                    DTColumnBuilder.newColumn("metadata.description").withTitle(i18nService.message("serverSettings.manageWem.description")).withOption('defaultContent', ''),
                    DTColumnBuilder.newColumn("eventDate").withTitle(i18nService.message("serverSettings.manageCampaigns.eventDate")),
                    DTColumnBuilder.newColumn("cost").withTitle(i18nService.message("serverSettings.manageCampaigns.event.cost")),
                    DTColumnBuilder.newColumn(null).withTitle(i18nService.message("serverSettings.manageWem.listAction")).notSortable()
                        .renderWith(function (data, type, full, meta) {
                            return "<button type=\"button\" class=\"btn btn-icon command-delete\" ng-click=\"deleteCampaignEvent('" + data.metadata.id + "', '" + data.metadata.name + "')\"><span class=\"md md-delete\"></span></button>";
                        })
                ];

                $scope.deleteCampaignEvent = function (eventId, eventName) {
                    genericModal.newAlertModal({
                        title: i18nService.message("serverSettings.manageWem.delete"),
                        bodyMessage: i18nService.format("serverSettings.manageCampaigns.event.delete.confirm", eventName)
                    }, function () {
                        campaignService.deleteCampaignEvent(eventId).success(function (result) {
                            $scope.campaignEvents = _.filter($scope.campaignEvents, function (item) {
                                return item.metadata.id != eventId;
                            });
                            $scope.dtInstance.dataTable.fnDraw();
                            $scope.campaignChart.draw();
                            $scope.campaignChart.options.customTooltips(false);
                        });
                    });
                };

                $scope.createCampaignEvent = function () {
                    var modalInstance = $modal.open({
                        templateUrl: ManagersContext.localTemplatesPath + '/campaigns/campaignevent-create-modal.html',
                        controller: 'CreateCampaignEventModalCtrl',
                        size: 'lg',
                        resolve: {
                            "currentCampaign": function () {
                                return $scope.currentCampaign;
                            }
                        }
                    });

                    modalInstance.result.then(function (newEvent) {
                        var id = ManagersUtils.generateId();
                        var campaignEventDate = moment(newEvent.eventDate).tz(newEvent.timezone.label);
                        campaignEventDate.hours(newEvent.startTime.getHours());
                        campaignEventDate.minutes(newEvent.startTime.getMinutes());
                        campaignEventDate.seconds(0);
                        var event = {
                            metadata: {
                                id: id,
                                name: newEvent.name,
                                description: newEvent.description,
                                scope: ManagersContext.dmfScope
                            },
                            eventDate: campaignEventDate.toISOString(),
                            cost: newEvent.cost,
                            currency: newEvent.currency.value,
                            campaignId: $scope.currentCampaign.metadata.id,
                            timezone: newEvent.timezone.label
                        };
                        campaignService.setCampaignEvent(event).success(function () {
                            $scope.campaignEvents.push(event);
                            $scope.dtInstance.dataTable.fnDraw();
                            $scope.campaignChart.options.customTooltips(false);
                        });
                    });
                };

                $scope.displayDate = function (date) {
                    return moment(date).tz($scope.currentCampaign.timezone).format('LLLL z');
                };

                $scope.setDtInstance = function (instance) {
                    $scope.dtInstance = instance;
                };
            }
        }])

    .controller('CreateCampaignEventModalCtrl', ['$scope', '$routeParams', '$resource', '$location', 'campaignService', '$modalInstance', 'i18nService', 'currentCampaign',
        function ($scope, $routeParams, $resource, $location, campaignService, $modalInstance, i18nService, currentCampaign) {
            //The new campaign
            $scope.currentCampaign = currentCampaign;

            $scope.campaignEvent = {};
            $scope.campaignEvent.eventDate = new Date();

            // Calendar functions
            $scope.open = function ($event, selector) {
                $event.preventDefault();
                $event.stopPropagation();
                if (selector == 'start')
                    $scope.startopened = true;
                if (selector == 'end')
                    $scope.endopened = true;
            };

            $scope.dateOptions = {
                formatYear: 'yyyy',
                startingDay: 1
            };

            $scope.formats = ['dd-MMMM-yyyy', 'yyyy/MM/dd', 'dd.MM.yyyy', 'shortDate'];
            $scope.format = $scope.formats[0];

            //Timepicker functions
            $scope.campaignEvent.startTime = new Date();

            $scope.ok = function () {
                $modalInstance.close($scope.campaignEvent);
            };

            $scope.cancel = function () {
                $modalInstance.dismiss('cancel');
            };

            $scope.campaignEvent.cost = 0.0;

            $scope.campaignEvent.currency = $scope.currencies[_.findIndex($scope.currencies, {value: currentCampaign.currency})];
            $scope.campaignEvent.timezone = $scope.timezones[_.findIndex($scope.timezones, {label: currentCampaign.timezone})];
        }]);